Overview
--------

This interface layer handles the communication between Spectrum Scale Manager and Spectrum Scale Client. The provider end of this interface provides the Spectrum Scale manager service. The consumer part requires the existence of a provider to function.
This interface also handles communication among Spectrum Scale manager Peer units.


Usage
------

##### Provides

This interface layer will set the following states, as appropriate:

  - `{relation_name}.joined` : The relation is established, but Manager may not yet have provided any connection or service information.

  - `{relation_name}.ready` : Manager has provided its connection string information to the client as well as the client has provided the required connection information to the Manager. The following methods will set the host and ssh keys information required by the Spectrum Scale client:
  
      - `set_hostname()` - This will set the hostname of the Spectrum Scale Manager.
      - `set_ssh_key()` - This will set the ssh keys(public and private).
      - `set_notify_client()` - This will set the notify_client flag when the manager unit has added the gpfs client to the cluster.



##### Requires
The Spectrum Scale client requires to be connected to the Spectrum Scale Manager to be part of GPFS Cluster. This interface layer will set the following states, as appropriate:

- `{relation_name}.joined` : The client charm has been related to a Spectrum Scale Manager charm. At this point, the charm waits for Manager configuration details.

- `{relation_name}.ready` : Spectrum Scale manager has provided the required connection information. 
The client charm can access the required information using the below methods:
  
  - `get_hostname()` 
  - `get_ip()` 
  - `get_priv_key()` 
  - `get_pub_key()`  
 
- `{relation_name}.client.ready` : Spectrum Scale manager has added client to the Cluster and the client is ready to be used.
 



##### Peers
This interface allows the peers of the Spectrum Scale manager deployment to be aware of each other. This interface layer will set the following states, as appropriate:

- `{relation_name}.joined` - A new peer in the Spectrum Scale manager service has joined. 

- `{relation_name}.available` -  Each manager unit has provided its connection informaion (hostname, ssh keys. storage disks location). The provided information can be accessed via the following methods:

  - `get_unitip()`
  - `get_hostname_peer()`
  - `get_pub_key()`
  - `get_storagedisk_peer()`
  - `gpfsclient_managerpeer_service()`
  


