from charms.reactive import RelationBase, hook, scopes
from charmhelpers.core import (
    hookenv,
)


class DistPeers(RelationBase):
    scope = scopes.UNIT

    @hook('{peers:gpfs}-relation-joined')
    def joined(self):
        conv = self.conversation()
        conv.remove_state('{relation_name}.departed')
        conv.set_state('{relation_name}.joined')
        
    @hook('{peers:gpfs}-relation-changed')
    def joined(self):
        conv = self.conversation()
        conv.remove_state('{relation_name}.departed')
        if  ((str(conv.get_remote('manager_hostname')) != "None") and (str(conv.get_remote('pubkey')) != "None")):
             conv.set_state('{relation_name}.available')
        if  (str(conv.get_remote('peer_gpfs_ready')) == 'ClusterReady'):
             conv.set_state('{relation_name}.cluster.ready')

        
    @hook('{peers:gpfs}-relation-departed')
    def departed(self):
        conv = self.conversation()
        conv.remove_state('{relation_name}.cluster.ready')
        conv.remove_state('{relation_name}.joined')
        conv.remove_state('{relation_name}.available')
        conv.set_state('{relation_name}.departed')

    def dismiss_departed(self):
        for conv in self.conversations():
            conv.remove_state('{relation_name}.departed')
            

    def dismiss_joined(self):
        for conv in self.conversations():
            conv.remove_state('{relation_name}.joined')
           
        
    def get_unitip(self):
        ip = []
        for conv in self.conversations():
            ip.append(conv.get_remote('private-address'))
        return ip


    def set_hostname_peer(self, manager_hostname):
        for conv in self.conversations():
            conv.set_remote('manager_hostname', manager_hostname)

    def set_ssh_key(self, pubkey):
        for conv in self.conversations():
            conv.set_remote(data={
            'pubkey':  pubkey,
        })


    def set_storagedisk_peer(self, devices_list):
        for conv in self.conversations():
            conv.set_remote('devices_list', devices_list)

    def notify_peerready(self, peer_gpfs_ready):
        for conv in self.conversations():
            conv.set_remote('peer_gpfs_ready', peer_gpfs_ready)

 
    def get_hostname_peer(self):
        host = []
        for conv in self.conversations():
            host.append(conv.get_remote('manager_hostname'))
        return host

    
    def get_pub_key(self):
        pub_ssh_key = []
        for conv in self.conversations():
            pub_ssh_key.append(conv.get_remote('pubkey'))
        return pub_ssh_key

    
    def get_storagedisk_peer(self):
        devices_list_peer = []
        for conv in self.conversations():
            devices_list_peer.append(conv.get_remote('devices_list'))
        return list(devices_list_peer)

    def gpfsclient_managerpeer_service(self):
        serv = []
        for conv in self.conversations():
            serv.append(conv.scope)
        return serv 
    
      
  
