from charmhelpers.core import hookenv
from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes
import socket
from charmhelpers.core import (
    hookenv,
)



class gpfsProvides(RelationBase):
    # Every unit connecting will get the same information
    scope = scopes.UNIT

    # Use some template magic to declare our relation(s)
    @hook('{provides:gpfs}-relation-joined')
    def joined(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departed')
        conversation.set_state('{relation_name}.joined')
        
        
    @hook('{provides:gpfs}-relation-changed')
    def changed(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departed')
        if (str(conversation.get_remote('hostname_client')) != "None"):
            conversation.set_state('{relation_name}.ready')
        
        
    @hook('{provides:gpfs}-relation-departed')
    def departed(self):
        # Remove the state that our relationship is now available to our principal layer(s)
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.ready')
        conversation.remove_state('{relation_name}.joined')
        conversation.set_state('{relation_name}.departed')

    def dismiss_departed(self):
        for conv in self.conversations():
            conv.remove_state('{relation_name}.departed')
                  

    def set_hostname(self, manager_hostname):
        for conv in self.conversations():
            conv.set_remote('manager_hostname', manager_hostname)

    def set_ssh_key(self, privkey, pubkey):
        for conv in self.conversations():
            conv.set_remote(data={
            'privkey': privkey,
            'pubkey':  pubkey,
        })
            
    def set_notify_client(self, notify_client):
        for conv in self.conversations():
            conv.set_remote('notify_client', notify_client)


    def get_hostname(self):
        host = []
        for conv in self.conversations():
            host.append(conv.get_remote('hostname_client'))
        return host

    def get_ip(self):
        ip = []
        for conv in self.conversations():
            ip.append(conv.get_remote('private-address'))
        return ip

    def gpfsclient_service(self):
        serv = []
        for conv in self.conversations():
            serv.append(conv.scope)
        return serv

