
from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes
import socket


class gpfsRequires(RelationBase):
    scope = scopes.UNIT

    @hook('{requires:gpfs}-relation-joined')
    def joined(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departed')
        conversation.set_state('{relation_name}.joined')
        
        
    @hook('{requires:gpfs}-relation-changed')
    def changed(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departed')
        if (str(conversation.get_remote('manager_hostname')) != "None"):
            conversation.set_state('{relation_name}.ready')
        if (str(conversation.get_remote('notify_client')) == "Yes"):
            conversation.set_state('{relation_name}.client-ready')

                   
    @hook('{requires:gpfs}-relation-departed')
    def departed(self):
         # Remove the state that our relationship is now available to our principal layer(s)
         conversation = self.conversation()
         conversation.remove_state('{relation_name}.client-ready')     
         conversation.remove_state('{relation_name}.ready')
         conversation.remove_state('{relation_name}.joined')
         conversation.set_state('{relation_name}.departed')  

    def dismiss_departed(self):
        for conv in self.conversations():
            conv.remove_state('{relation_name}.departed')      
           
            
    def set_hostname(self, hostname_client):
        for conv in self.conversations():
            conv.set_remote('hostname_client', hostname_client)
        
       
    def get_hostname(self):
        host = []
        for conv in self.conversations():
            host.append(conv.get_remote('manager_hostname'))
        return host


    def get_ip(self):
        ip = []
        for conv in self.conversations():
            ip.append(conv.get_remote('private-address'))
        return ip


    def get_priv_key(self):
        priv_ssh_key = []
        for conv in self.conversations():
            priv_ssh_key.append(conv.get_remote('privkey'))
        return priv_ssh_key


    def get_pub_key(self):
        pub_ssh_key = []
        for conv in self.conversations():
            pub_ssh_key.append(conv.get_remote('pubkey'))
        return pub_ssh_key
  
